<template>
  <div v-if="loading" class="loading-page">
    <div
      v-load="loading"
      load-background="white"
      load-type="folding-cube"
      class="mt-15"
    ></div>
  </div>
  <section v-else class="my-8">
    <v-container>
      <v-row justify="center">
        <v-col cols="10" sm="8" md="6">
          <h2
            v-if="isTokenVerified"
            class="section-title text-center font-weight-black font-poppins"
          >
            Thank you for authorizing your data for blockchain
          </h2>
          <h2
            v-else
            class="section-title text-center font-weight-black font-poppins"
          >
            Sorry, we coudn't verify the email token.
          </h2>
        </v-col>
      </v-row>
      <v-row justify="center">
        <v-col v-if="isTokenVerified" cols="9" sm="7" md="5">
          <p class="text-center font-poppins section-description">
            <strong>Lorem ipsum dolor sit amet</strong>, consetetur sadipscing
            elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore
            magna aliquyam erat, sed diam voluptua. At vero eos et.
          </p>
          <p class="text-center font-poppins section-description">
            Cras nisl nibh, viverra eu enim
            <strong>gravida, auctor tempus est.</strong> Nullam ornare arcu nec
            sodales aliquam.
          </p>
        </v-col>
        <v-col v-else cols="9" sm="7" md="5">
          <p class="text-center font-poppins section-description">
            Please, try again later or contact the administrator.
          </p>
        </v-col>
      </v-row>
      <v-row justify="center">
        <v-col cols="7" sm="5" md="3">
          <v-img
            v-if="isTokenVerified"
            src="https://firebasestorage.googleapis.com/v0/b/unicef-certs.appspot.com/o/brand%2Fimages%2Fauthorized-ok.png?alt=media&token=4b957518-ea17-4477-bcf7-f3ea188268de"
          >
          </v-img>
          <v-img
            v-else
            src="https://firebasestorage.googleapis.com/v0/b/unicef-certs.appspot.com/o/brand%2Fimages%2Fauthorized-error.png?alt=media&token=57fe06d5-5708-46a9-9a67-77bf46728f8f"
          ></v-img>
        </v-col>
      </v-row>

      <v-row justify="center">
        <v-col cols="6" sm="3" class="text-center">
          <v-btn
            width="150px"
            color="#374EA2"
            dark
            class="text-none font-poppins font-weight-medium"
            to="/"
          >
            Home
          </v-btn>
        </v-col>
      </v-row>
    </v-container>
  </section>
</template>

<script lang="ts">
import Vue from 'vue'
import axios from 'axios'
export default Vue.extend({
  data() {
    return {
      urlEndpoints: process.env.OSCITY_ENDPOINTS_URL,
      isTokenVerified: false,
      loading: true,
    }
  },
  mounted() {
    this.verifyToken()
  },
  methods: {
    async verifyToken() {
      try {
        const response = await axios.post(
          `${this.urlEndpoints}/validateToken`,
          {
            paramEncode: this.$route.query.token,
          }
        )
        const email = response.data.email
        await this.$fire.firestore
          .collection('certificates')
          .where('email', '==', email)
          .get()
          .then((querySnapshot: any) => {
            if (querySnapshot.size > 0) {
              querySnapshot.forEach((certificate: any) => {
                this.$fire.firestore
                  .collection('certificates')
                  .doc(certificate.id)
                  .update({ authorized: true })
              })
              this.isTokenVerified = true
            }
          })
      } catch (error) {
        this.isTokenVerified = false
        console.error(error)
      }
      this.loading = false
    },
  },
})
</script>

<style scoped>
.section-title {
  font-size: 2.8125rem;
  color: #1976d2;
}

.section-description {
  color: #4e4e4e;
}

.v-btn.v-size--default {
  font-size: 15px !important;
}

.loading-page {
  position: fixed;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  padding-top: 200px;
  margin: auto;
}
</style>
